--- old/usr/src/uts/common/io/scsi/targets/sd.c	Mon Aug  5 17:31:49 2019
+++ new/usr/src/uts/common/io/scsi/targets/sd.c	Mon Aug  5 17:31:49 2019
@@ -7092,115 +6758,25 @@
 static int
 sdattach(dev_info_t *devi, ddi_attach_cmd_t cmd)
 {
-	switch (cmd) {
-	case DDI_ATTACH:
-		return (sd_unit_attach(devi));
-	case DDI_RESUME:
-		return (sd_ddi_resume(devi));
-	default:
-		break;
-	}
-	return (DDI_FAILURE);
-}
-
-
-/*
- *    Function: sddetach
- *
- * Description: Driver's detach(9E) entry point function.
- *
- *   Arguments: devi - opaque device info handle
- *		cmd  - detach  type
- *
- * Return Code: DDI_SUCCESS
- *		DDI_FAILURE
- *
- *     Context: Kernel thread context
- */
-
-static int
-sddetach(dev_info_t *devi, ddi_detach_cmd_t cmd)
-{
-	switch (cmd) {
-	case DDI_DETACH:
-		return (sd_unit_detach(devi));
-	case DDI_SUSPEND:
-		return (sd_ddi_suspend(devi));
-	default:
-		break;
-	}
-	return (DDI_FAILURE);
-}
-
-
-/*
- *     Function: sd_sync_with_callback
- *
- *  Description: Prevents sd_unit_attach or sd_unit_detach from freeing the soft
- *		 state while the callback routine is active.
- *
- *    Arguments: un: softstate structure for the instance
- *
- *	Context: Kernel thread context
- */
-
-static void
-sd_sync_with_callback(struct sd_lun *un)
-{
-	ASSERT(un != NULL);
-
-	mutex_enter(SD_MUTEX(un));
-
-	ASSERT(un->un_in_callback >= 0);
-
-	while (un->un_in_callback > 0) {
-		mutex_exit(SD_MUTEX(un));
-		delay(2);
-		mutex_enter(SD_MUTEX(un));
-	}
-
-	mutex_exit(SD_MUTEX(un));
-}
-
-/*
- *    Function: sd_unit_attach
- *
- * Description: Performs DDI_ATTACH processing for sdattach(). Allocates
- *		the soft state structure for the device and performs
- *		all necessary structure and device initializations.
- *
- *   Arguments: devi: the system's dev_info_t for the device.
- *
- * Return Code: DDI_SUCCESS if attach is successful.
- *		DDI_FAILURE if any part of the attach fails.
- *
- *     Context: Called at attach(9e) time for the DDI_ATTACH flag.
- *		Kernel thread context only.  Can sleep.
- */
-
-static int
-sd_unit_attach(dev_info_t *devi)
-{
 	struct	scsi_device	*devp;
 	struct	sd_lun		*un;
 	char			*variantp;
-	char			name_str[48];
-	int	reservation_flag = SD_TARGET_IS_UNRESERVED;
 	int	instance;
-	int	rval;
-	int	wc_enabled;
-	int	wc_changeable;
 	int	tgt;
-	uint64_t	capacity;
-	uint_t		lbasize = 0;
 	dev_info_t	*pdip = ddi_get_parent(devi);
-	int		offbyone = 0;
-	int		geom_label_valid = 0;
+	int		max_xfer_size;
 	sd_ssc_t	*ssc;
-	int		status;
 	struct sd_fm_internal	*sfip = NULL;
-	int		max_xfer_size;
 
+	switch (cmd) {
+	case DDI_ATTACH:
+		break;
+	case DDI_RESUME:
+		return (sd_ddi_resume(devi));
+	default:
+		return (DDI_FAILURE);
+	}
+
 	/*
 	 * Retrieve the target driver's private data area. This was set
 	 * up by the HBA.
@@ -7295,7 +6871,7 @@
 	 * probably better to halt here than just fail the attach....)
 	 */
 	if ((un = ddi_get_soft_state(sd_state, instance)) == NULL) {
-		panic("sd_unit_attach: NULL soft state on instance:0x%x",
+		panic("sdattach: NULL soft state on instance:0x%x",
 		    instance);
 		/*NOTREACHED*/
 	}
@@ -7341,92 +6917,51 @@
 		break;
 	}
 
-	/*
-	 * Try to read the interconnect type from the HBA.
-	 *
-	 * Note: This driver is currently compiled as two binaries, a parallel
-	 * scsi version (sd) and a fibre channel version (ssd). All functional
-	 * differences are determined at compile time. In the future a single
-	 * binary will be provided and the interconnect type will be used to
-	 * differentiate between fibre and parallel scsi behaviors. At that time
-	 * it will be necessary for all fibre channel HBAs to support this
-	 * property.
-	 *
-	 * set un_f_is_fiber to TRUE ( default fiber )
-	 */
-	un->un_f_is_fibre = TRUE;
+	/* Try to read the interconnect type from the HBA */
+	un->un_f_is_fibre = FALSE;
 	switch (scsi_ifgetcap(SD_ADDRESS(un), "interconnect-type", -1)) {
 	case INTERCONNECT_SSA:
+		un->un_f_is_fibre = TRUE;
 		un->un_interconnect_type = SD_INTERCONNECT_SSA;
 		SD_INFO(SD_LOG_ATTACH_DETACH, un,
-		    "sd_unit_attach: un:0x%p SD_INTERCONNECT_SSA\n", un);
+		    "sdattach: un:0x%p SD_INTERCONNECT_SSA\n", un);
 		break;
 	case INTERCONNECT_PARALLEL:
-		un->un_f_is_fibre = FALSE;
 		un->un_interconnect_type = SD_INTERCONNECT_PARALLEL;
 		SD_INFO(SD_LOG_ATTACH_DETACH, un,
-		    "sd_unit_attach: un:0x%p SD_INTERCONNECT_PARALLEL\n", un);
+		    "sdattach: un:0x%p SD_INTERCONNECT_PARALLEL\n", un);
 		break;
 	case INTERCONNECT_SAS:
-		un->un_f_is_fibre = FALSE;
 		un->un_interconnect_type = SD_INTERCONNECT_SAS;
 		un->un_node_type = DDI_NT_BLOCK_SAS;
 		SD_INFO(SD_LOG_ATTACH_DETACH, un,
-		    "sd_unit_attach: un:0x%p SD_INTERCONNECT_SAS\n", un);
+		    "sdattach: un:0x%p SD_INTERCONNECT_SAS\n", un);
 		break;
 	case INTERCONNECT_SATA:
-		un->un_f_is_fibre = FALSE;
 		un->un_interconnect_type = SD_INTERCONNECT_SATA;
 		SD_INFO(SD_LOG_ATTACH_DETACH, un,
-		    "sd_unit_attach: un:0x%p SD_INTERCONNECT_SATA\n", un);
+		    "sdattach: un:0x%p SD_INTERCONNECT_SATA\n", un);
 		break;
 	case INTERCONNECT_FIBRE:
+		un->un_f_is_fibre = TRUE;
 		un->un_interconnect_type = SD_INTERCONNECT_FIBRE;
 		SD_INFO(SD_LOG_ATTACH_DETACH, un,
-		    "sd_unit_attach: un:0x%p SD_INTERCONNECT_FIBRE\n", un);
+		    "sdattach: un:0x%p SD_INTERCONNECT_FIBRE\n", un);
 		break;
 	case INTERCONNECT_FABRIC:
+		un->un_f_is_fibre = TRUE;
 		un->un_interconnect_type = SD_INTERCONNECT_FABRIC;
 		un->un_node_type = DDI_NT_BLOCK_FABRIC;
 		SD_INFO(SD_LOG_ATTACH_DETACH, un,
-		    "sd_unit_attach: un:0x%p SD_INTERCONNECT_FABRIC\n", un);
+		    "sdattach: un:0x%p SD_INTERCONNECT_FABRIC\n", un);
 		break;
 	default:
-#ifdef SD_DEFAULT_INTERCONNECT_TYPE
 		/*
-		 * The HBA does not support the "interconnect-type" property
-		 * (or did not provide a recognized type).
-		 *
-		 * Note: This will be obsoleted when a single fibre channel
-		 * and parallel scsi driver is delivered. In the meantime the
-		 * interconnect type will be set to the platform default.If that
-		 * type is not parallel SCSI, it means that we should be
-		 * assuming "ssd" semantics. However, here this also means that
-		 * the FC HBA is not supporting the "interconnect-type" property
-		 * like we expect it to, so log this occurrence.
+		 * The default is to assume that if a device does not support
+		 * the "interconnect-type" property it is a parallel SCSI HBA
+		 * and set the interconnect type for parallel SCSI.
 		 */
-		un->un_interconnect_type = SD_DEFAULT_INTERCONNECT_TYPE;
-		if (!SD_IS_PARALLEL_SCSI(un)) {
-			SD_INFO(SD_LOG_ATTACH_DETACH, un,
-			    "sd_unit_attach: un:0x%p Assuming "
-			    "INTERCONNECT_FIBRE\n", un);
-		} else {
-			SD_INFO(SD_LOG_ATTACH_DETACH, un,
-			    "sd_unit_attach: un:0x%p Assuming "
-			    "INTERCONNECT_PARALLEL\n", un);
-			un->un_f_is_fibre = FALSE;
-		}
-#else
-		/*
-		 * Note: This source will be implemented when a single fibre
-		 * channel and parallel scsi driver is delivered. The default
-		 * will be to assume that if a device does not support the
-		 * "interconnect-type" property it is a parallel SCSI HBA and
-		 * we will set the interconnect type for parallel scsi.
-		 */
 		un->un_interconnect_type = SD_INTERCONNECT_PARALLEL;
-		un->un_f_is_fibre = FALSE;
-#endif
 		break;
 	}
 
@@ -7444,6 +6979,9 @@
 		}
 	}
 
+	(void) ddi_prop_update_int(DDI_DEV_T_NONE, devi,
+	    "allow-unconstrained-retire", 1);
+
 	/*
 	 * Initialize the Request Sense command for the target
 	 */
@@ -7451,22 +6989,8 @@
 		goto alloc_rqs_failed;
 	}
 
-	/*
-	 * Set un_retry_count with SD_RETRY_COUNT, this is ok for Sparc
-	 * with separate binary for sd and ssd.
-	 *
-	 * x86 has 1 binary, un_retry_count is set base on connection type.
-	 * The hardcoded values will go away when Sparc uses 1 binary
-	 * for sd and ssd.  This hardcoded values need to match
-	 * SD_RETRY_COUNT in sddef.h
-	 * The value used is base on interconnect type.
-	 * fibre = 3, parallel = 5
-	 */
-#if defined(__i386) || defined(__amd64)
+	/* The value used is base on interconnect type */
 	un->un_retry_count = un->un_f_is_fibre ? 3 : 5;
-#else
-	un->un_retry_count = SD_RETRY_COUNT;
-#endif
 
 	/*
 	 * Set the per disk retry count to the default number of retries
@@ -7493,28 +7017,33 @@
 	un->un_reset_retry_count = (un->un_retry_count / 2);
 
 	/*
-	 * Set the victim_retry_count to the default un_retry_count
+	 * Set the victim_retry_count to the default un_retry_count.
+	 * This value is used in addition to the standard retry count.
+	 * This can be overridden by entries in sd.conf or the device
+	 * config table.
 	 */
-	un->un_victim_retry_count = (2 * un->un_retry_count);
+	un->un_victim_retry_count = un->un_retry_count;
 
 	/*
 	 * Set the reservation release timeout to the default value of
-	 * 5 seconds. This can be overridden by entries in ssd.conf or the
+	 * 5 seconds. This can be overridden by entries in sd.conf or the
 	 * device config table.
 	 */
 	un->un_reserve_release_time = 5;
 
+	un->un_io_time = sd_io_time;
+
+	un->un_slow_io_threshold = sd_slow_io_threshold;
+
+	un->un_f_lun_reset_enabled = sd_enable_lun_reset;
+
 	/*
 	 * Set up the default maximum transfer size. Note that this may
 	 * get updated later in the attach, when setting up default wide
 	 * operations for disks.
 	 */
-#if defined(__i386) || defined(__amd64)
 	un->un_max_xfer_size = (uint_t)SD_DEFAULT_MAX_XFER_SIZE;
 	un->un_partial_dma_supported = 1;
-#else
-	un->un_max_xfer_size = (uint_t)maxphys;
-#endif
 
 	/*
 	 * Get "allow bus device reset" property (defaults to "enabled" if
@@ -7530,12 +7059,12 @@
 		    "allow-bus-device-reset", 1) != 0) {
 			un->un_f_allow_bus_device_reset = TRUE;
 			SD_INFO(SD_LOG_ATTACH_DETACH, un,
-			    "sd_unit_attach: un:0x%p Bus device reset "
+			    "sdattach: un:0x%p Bus device reset "
 			    "enabled\n", un);
 		} else {
 			un->un_f_allow_bus_device_reset = FALSE;
 			SD_INFO(SD_LOG_ATTACH_DETACH, un,
-			    "sd_unit_attach: un:0x%p Bus device reset "
+			    "sdattach: un:0x%p Bus device reset "
 			    "disabled\n", un);
 		}
 	}
@@ -7554,7 +7083,7 @@
 	if (ddi_prop_get_int(DDI_DEV_T_ANY, devi, 0, "atapi", -1) != -1) {
 		un->un_f_cfg_is_atapi = TRUE;
 		SD_INFO(SD_LOG_ATTACH_DETACH, un,
-		    "sd_unit_attach: un:0x%p Atapi device\n", un);
+		    "sdattach: un:0x%p Atapi device\n", un);
 	}
 	if (ddi_prop_lookup_string(DDI_DEV_T_ANY, devi, 0, "variant",
 	    &variantp) == DDI_PROP_SUCCESS) {
@@ -7561,17 +7090,23 @@
 		if (strcmp(variantp, "atapi") == 0) {
 			un->un_f_cfg_is_atapi = TRUE;
 			SD_INFO(SD_LOG_ATTACH_DETACH, un,
-			    "sd_unit_attach: un:0x%p Atapi device\n", un);
+			    "sdattach: un:0x%p Atapi device\n", un);
 		}
 		ddi_prop_free(variantp);
 	}
 
-	un->un_cmd_timeout	= SD_IO_TIME;
+	un->un_cmd_timeout = ((ISCD(un)) ? 2 : 1) * (ushort_t)un->un_io_time;
+	un->un_uscsi_timeout = un->un_cmd_timeout;
+	un->un_busy_timeout = SD_BSY_TIMEOUT;
 
-	un->un_busy_timeout  = SD_BSY_TIMEOUT;
-
-	/* Info on current states, statuses, etc. (Updated frequently) */
-	un->un_state		= SD_STATE_NORMAL;
+	/*
+	 * Info on current states, statuses, etc. (Updated frequently)
+	 *
+	 * Current state is ATTACHING until we finished sd_unit_attach.
+	 * Last state is NORMAL so that sd_unit_attach can Restore_state()
+	 * when it finishes successfully.
+	 */
+	un->un_state		= SD_STATE_ATTACHING;
 	un->un_last_state	= SD_STATE_NORMAL;
 
 	/* Control & status info for command throttling */
@@ -7585,6 +7120,10 @@
 		un->un_f_use_adaptive_throttle = FALSE;
 	}
 
+	/* Unit detach has to pause until outstanding commands abort */
+	un->un_f_detach_waiting = 0;
+	cv_init(&un->un_detach_cv, NULL, CV_DRIVER, NULL);
+
 	/* Removable media support. */
 	cv_init(&un->un_state_cv, NULL, CV_DRIVER, NULL);
 	un->un_mediastate		= DKIO_NONE;
@@ -7627,6 +7166,7 @@
 	 * set it before calling sd_read_unit_properties().
 	 */
 	un->un_phy_blocksize = DEV_BSIZE;
+	un->un_f_sdconf_phy_blocksize = FALSE;
 
 	/*
 	 * Retrieve the properties from the static driver table or the driver
@@ -7638,7 +7178,7 @@
 	 */
 	sd_read_unit_properties(un);
 	SD_TRACE(SD_LOG_ATTACH_DETACH, un,
-	    "sd_unit_attach: un:0x%p property configuration complete.\n", un);
+	    "sdattach: un:0x%p property configuration complete.\n", un);
 
 	/*
 	 * Only if a device has "hotpluggable" property, it is
@@ -7724,14 +7264,47 @@
 		kstat_install(un->un_stats);
 	}
 	SD_TRACE(SD_LOG_ATTACH_DETACH, un,
-	    "sd_unit_attach: un:0x%p un_stats created\n", un);
+	    "sdattach: un:0x%p un_stats created\n", un);
 
+	un->un_unmapstats_ks = kstat_create(sd_label, instance, "unmapstats",
+	    "misc", KSTAT_TYPE_NAMED, sizeof (*un->un_unmapstats) /
+	    sizeof (kstat_named_t), 0);
+	if (un->un_unmapstats_ks) {
+		un->un_unmapstats = un->un_unmapstats_ks->ks_data;
+
+		kstat_named_init(&un->un_unmapstats->us_cmds,
+		    "commands", KSTAT_DATA_UINT64);
+		kstat_named_init(&un->un_unmapstats->us_errs,
+		    "errors", KSTAT_DATA_UINT64);
+		kstat_named_init(&un->un_unmapstats->us_extents,
+		    "extents", KSTAT_DATA_UINT64);
+		kstat_named_init(&un->un_unmapstats->us_bytes,
+		    "bytes", KSTAT_DATA_UINT64);
+
+		kstat_install(un->un_unmapstats_ks);
+	} else {
+		cmn_err(CE_NOTE, "!Cannot create unmap kstats for disk %d",
+		    instance);
+	}
+
+	un->un_lat_ksp = kstat_create(sd_label, instance, "io_latency",
+	    "io_latency", KSTAT_TYPE_RAW, sizeof (un_lat_stat_t),
+	    KSTAT_FLAG_PERSISTENT);
+
+	if (un->un_lat_ksp != NULL) {
+		un->un_lat_ksp->ks_lock = SD_MUTEX(un);
+		un->un_lat_stats = (un_lat_stat_t *)un->un_lat_ksp->ks_data;
+		kstat_install(un->un_lat_ksp);
+	} else {
+		un->un_lat_stats = NULL;
+	}
+
 	sd_create_errstats(un, instance);
 	if (un->un_errstats == NULL) {
 		goto create_errstats_failed;
 	}
 	SD_TRACE(SD_LOG_ATTACH_DETACH, un,
-	    "sd_unit_attach: un:0x%p errstats created\n", un);
+	    "sdattach: un:0x%p errstats created\n", un);
 
 	/*
 	 * The following if/else code was relocated here from below as part
@@ -7755,7 +7328,7 @@
 			    1, 1) == 1) {
 				un->un_tagflags = FLAG_STAG;
 				SD_INFO(SD_LOG_ATTACH_DETACH, un,
-				    "sd_unit_attach: un:0x%p tag queueing "
+				    "sdattach: un:0x%p tag queueing "
 				    "enabled\n", un);
 			} else if (scsi_ifgetcap(SD_ADDRESS(un),
 			    "untagged-qing", 0) == 1) {
@@ -7776,7 +7349,7 @@
 			un->un_f_opt_queueing = FALSE;
 			un->un_saved_throttle = un->un_throttle = 1;
 			SD_INFO(SD_LOG_ATTACH_DETACH, un,
-			    "sd_unit_attach: un:0x%p no tag queueing\n", un);
+			    "sdattach: un:0x%p no tag queueing\n", un);
 		}
 
 		/*
@@ -7785,22 +7358,14 @@
 		if (SD_IS_SERIAL(un)) {
 			un->un_max_xfer_size =
 			    ddi_getprop(DDI_DEV_T_ANY, devi, 0,
-			    sd_max_xfer_size, SD_MAX_XFER_SIZE);
+			    "sd_max_xfer_size", SD_MAX_XFER_SIZE);
 			SD_INFO(SD_LOG_ATTACH_DETACH, un,
-			    "sd_unit_attach: un:0x%p max transfer "
+			    "sdattach: un:0x%p max transfer "
 			    "size=0x%x\n", un, un->un_max_xfer_size);
 
 		}
 
 		/* Setup or tear down default wide operations for disks */
-
-		/*
-		 * Note: Legacy: it may be possible for both "sd_max_xfer_size"
-		 * and "ssd_max_xfer_size" to exist simultaneously on the same
-		 * system and be set to different values. In the future this
-		 * code may need to be updated when the ssd module is
-		 * obsoleted and removed from the system. (4299588)
-		 */
 		if (SD_IS_PARALLEL_SCSI(un) &&
 		    (devp->sd_inq->inq_rdf == RDF_SCSI2) &&
 		    (devp->sd_inq->inq_wbus16 || devp->sd_inq->inq_wbus32)) {
@@ -7807,7 +7372,7 @@
 			if (scsi_ifsetcap(SD_ADDRESS(un), "wide-xfer",
 			    1, 1) == 1) {
 				SD_INFO(SD_LOG_ATTACH_DETACH, un,
-				    "sd_unit_attach: un:0x%p Wide Transfer "
+				    "sdattach: un:0x%p Wide Transfer "
 				    "enabled\n", un);
 			}
 
@@ -7818,9 +7383,9 @@
 			if (un->un_saved_throttle == sd_max_throttle) {
 				un->un_max_xfer_size =
 				    ddi_getprop(DDI_DEV_T_ANY, devi, 0,
-				    sd_max_xfer_size, SD_MAX_XFER_SIZE);
+				    "sd_max_xfer_size", SD_MAX_XFER_SIZE);
 				SD_INFO(SD_LOG_ATTACH_DETACH, un,
-				    "sd_unit_attach: un:0x%p max transfer "
+				    "sdattach: un:0x%p max transfer "
 				    "size=0x%x\n", un, un->un_max_xfer_size);
 			}
 		} else {
@@ -7827,7 +7392,7 @@
 			if (scsi_ifsetcap(SD_ADDRESS(un), "wide-xfer",
 			    0, 1) == 1) {
 				SD_INFO(SD_LOG_ATTACH_DETACH, un,
-				    "sd_unit_attach: un:0x%p "
+				    "sdattach: un:0x%p "
 				    "Wide Transfer disabled\n", un);
 			}
 		}
@@ -7834,7 +7399,7 @@
 	} else {
 		un->un_tagflags = FLAG_STAG;
 		un->un_max_xfer_size = ddi_getprop(DDI_DEV_T_ANY,
-		    devi, 0, sd_max_xfer_size, SD_MAX_XFER_SIZE);
+		    devi, 0, "sd_max_xfer_size", SD_MAX_XFER_SIZE);
 	}
 
 	/*
@@ -7842,25 +7407,22 @@
 	 */
 	if (un->un_f_lun_reset_enabled) {
 		if (scsi_ifsetcap(SD_ADDRESS(un), "lun-reset", 1, 1) == 1) {
-			SD_INFO(SD_LOG_ATTACH_DETACH, un, "sd_unit_attach: "
+			SD_INFO(SD_LOG_ATTACH_DETACH, un, "sdattach: "
 			    "un:0x%p lun_reset capability set\n", un);
 		} else {
-			SD_INFO(SD_LOG_ATTACH_DETACH, un, "sd_unit_attach: "
+			SD_INFO(SD_LOG_ATTACH_DETACH, un, "sdattach: "
 			    "un:0x%p lun-reset capability not set\n", un);
 		}
 	}
 
 	/*
-	 * Adjust the maximum transfer size. This is to fix
+	 * XXX Adjust the maximum transfer size. This was to fix
 	 * the problem of partial DMA support on SPARC. Some
 	 * HBA driver, like aac, has very small dma_attr_maxxfer
 	 * size, which requires partial DMA support on SPARC.
-	 * In the future the SPARC pci nexus driver may solve
-	 * the problem instead of this fix.
 	 */
 	max_xfer_size = scsi_ifgetcap(SD_ADDRESS(un), "dma-max", 1);
 	if ((max_xfer_size > 0) && (max_xfer_size < un->un_max_xfer_size)) {
-		/* We need DMA partial even on sparc to ensure sddump() works */
 		un->un_max_xfer_size = max_xfer_size;
 		if (un->un_partial_dma_supported == 0)
 			un->un_partial_dma_supported = 1;
@@ -7870,7 +7432,7 @@
 		if (ddi_xbuf_attr_setup_brk(un->un_xbuf_attr,
 		    un->un_max_xfer_size) == 1) {
 			un->un_buf_breakup_supported = 1;
-			SD_INFO(SD_LOG_ATTACH_DETACH, un, "sd_unit_attach: "
+			SD_INFO(SD_LOG_ATTACH_DETACH, un, "sdattach: "
 			    "un:0x%p Buf breakup enabled\n", un);
 		}
 	}
@@ -7884,12 +7446,10 @@
 		un->un_pkt_flags = 0;
 	}
 
-	/* Initialize sd_ssc_t for internal uscsi commands */
-	ssc = sd_ssc_init(un);
 	scsi_fm_init(devp);
 
 	/*
-	 * Allocate memory for SCSI FMA stuffs.
+	 * Allocate memory for SCSI FMA stuff.
 	 */
 	un->un_fm_private =
 	    kmem_zalloc(sizeof (struct sd_fm_internal), KM_SLEEP);
@@ -7924,15 +7484,283 @@
 			sfip->fm_log_level = SD_FM_LOG_SILENT;
 	}
 
+	/* Initialize sd_ssc_t for internal uscsi commands */
+	ssc = sd_ssc_init(un);
+
+	mutex_enter(SD_MUTEX(un));
 	/*
+	 * Initialize the devid for the unit. Indicate target reservation so
+	 * that no real I/O is done for devices that need devid fabrication.
+	 * We will try again in sd_unit_attach() if necessary.
+	 */
+	if (un->un_f_devid_supported) {
+		sd_register_devid(ssc, devi, SD_TARGET_IS_RESERVED);
+	}
+	mutex_exit(SD_MUTEX(un));
+
+	/* Uninitialize sd_ssc_t pointer */
+	sd_ssc_fini(ssc);
+
+	cmlb_alloc_handle(&un->un_cmlbhandle);
+
+	if (cmlb_attach(devi, &sd_tgops, (int)devp->sd_inq->inq_dtype,
+	    VOID2BOOLEAN(un->un_f_has_removable_media != 0),
+	    VOID2BOOLEAN(un->un_f_is_hotpluggable != 0),
+	    un->un_node_type, 0, un->un_cmlbhandle,
+	    (void *)SD_PATH_DIRECT) != 0) {
+		goto cmlb_attach_failed;
+	}
+
+	/*
 	 * At this point in the attach, we have enough info in the
 	 * soft state to be able to issue commands to the target.
 	 *
+	 * Schedule a taskq to finish attach to avoid holding the
+	 * device tree lock for too long. If this fails, rollback
+	 * and fail the attach.
+	 */
+
+	if (taskq_dispatch(sd_tq, sd_unit_attach, devi, KM_PUSHPAGE) != NULL)
+		return (DDI_SUCCESS);
+
+	cmlb_detach(un->un_cmlbhandle, (void *)SD_PATH_DIRECT);
+	cmlb_free_handle(&un->un_cmlbhandle);
+
+cmlb_attach_failed:
+	mutex_enter(SD_MUTEX(un));
+
+	/* Deallocate SCSI FMA memory spaces */
+	kmem_free(un->un_fm_private, sizeof (struct sd_fm_internal));
+
+	/* Cancel callback for SD_PATH_DIRECT_PRIORITY cmd. restart */
+	if (un->un_direct_priority_timeid != NULL) {
+		timeout_id_t temp_id = un->un_direct_priority_timeid;
+		un->un_direct_priority_timeid = NULL;
+		mutex_exit(SD_MUTEX(un));
+		(void) untimeout(temp_id);
+		mutex_enter(SD_MUTEX(un));
+	}
+
+	/* Cancel any pending start/stop timeouts */
+	if (un->un_startstop_timeid != NULL) {
+		timeout_id_t temp_id = un->un_startstop_timeid;
+		un->un_startstop_timeid = NULL;
+		mutex_exit(SD_MUTEX(un));
+		(void) untimeout(temp_id);
+		mutex_enter(SD_MUTEX(un));
+	}
+
+	/* Cancel any pending reset-throttle timeouts */
+	if (un->un_reset_throttle_timeid != NULL) {
+		timeout_id_t temp_id = un->un_reset_throttle_timeid;
+		un->un_reset_throttle_timeid = NULL;
+		mutex_exit(SD_MUTEX(un));
+		(void) untimeout(temp_id);
+		mutex_enter(SD_MUTEX(un));
+	}
+
+	/* Cancel rmw warning message timeouts */
+	if (un->un_rmw_msg_timeid != NULL) {
+		timeout_id_t temp_id = un->un_rmw_msg_timeid;
+		un->un_rmw_msg_timeid = NULL;
+		mutex_exit(SD_MUTEX(un));
+		(void) untimeout(temp_id);
+		mutex_enter(SD_MUTEX(un));
+	}
+
+	/* Cancel any pending retry timeouts */
+	if (un->un_retry_timeid != NULL) {
+		timeout_id_t temp_id = un->un_retry_timeid;
+		un->un_retry_timeid = NULL;
+		mutex_exit(SD_MUTEX(un));
+		(void) untimeout(temp_id);
+		mutex_enter(SD_MUTEX(un));
+	}
+
+	/* Cancel any pending delayed cv broadcast timeouts */
+	if (un->un_dcvb_timeid != NULL) {
+		timeout_id_t temp_id = un->un_dcvb_timeid;
+		un->un_dcvb_timeid = NULL;
+		mutex_exit(SD_MUTEX(un));
+		(void) untimeout(temp_id);
+		mutex_enter(SD_MUTEX(un));
+	}
+
+	mutex_exit(SD_MUTEX(un));
+
+	/* There should not be any in-progress I/O so ASSERT this check */
+	ASSERT(un->un_ncmds_in_transport == 0);
+	ASSERT(un->un_ncmds_in_driver == 0);
+
+	/* Do not free the softstate if the callback routine is active */
+	sd_sync_with_callback(un);
+
+	/*
+	 * Partition stats apparently are not used with removables. These would
+	 * not have been created during attach, so no need to clean them up...
+	 */
+	if (un->un_errstats != NULL) {
+		kstat_delete(un->un_errstats);
+		un->un_errstats = NULL;
+	}
+
+create_errstats_failed:
+
+	if (un->un_stats != NULL) {
+		kstat_delete(un->un_stats);
+		un->un_stats = NULL;
+	}
+
+	if (un->un_unmapstats != NULL) {
+		kstat_delete(un->un_unmapstats_ks);
+		un->un_unmapstats_ks = NULL;
+		un->un_unmapstats = NULL;
+	}
+
+	if (un->un_lat_ksp != NULL) {
+		kstat_delete(un->un_lat_ksp);
+		un->un_lat_ksp = NULL;
+		un->un_lat_stats = NULL;
+	}
+
+	ddi_xbuf_attr_unregister_devinfo(un->un_xbuf_attr, devi);
+	ddi_xbuf_attr_destroy(un->un_xbuf_attr);
+
+	ddi_prop_remove_all(devi);
+	sema_destroy(&un->un_semoclose);
+	cv_destroy(&un->un_state_cv);
+	cv_destroy(&un->un_detach_cv);
+	sd_free_rqs(un);
+
+alloc_rqs_failed:
+
+	devp->sd_private = NULL;
+	bzero(un, sizeof (struct sd_lun));	/* Clear any stale data! */
+
+	/*
+	 * Note: the man pages are unclear as to whether or not doing a
+	 * ddi_soft_state_free(sd_state, instance) is the right way to
+	 * clean up after the ddi_soft_state_zalloc() if the subsequent
+	 * ddi_get_soft_state() fails.  The implication seems to be
+	 * that the get_soft_state cannot fail if the zalloc succeeds.
+	 */
+	ddi_soft_state_free(sd_state, instance);
+
+probe_failed:
+	scsi_unprobe(devp);
+
+	return (DDI_FAILURE);
+}
+
+
+/*
+ *    Function: sddetach
+ *
+ * Description: Driver's detach(9E) entry point function.
+ *
+ *   Arguments: devi - opaque device info handle
+ *		cmd  - detach  type
+ *
+ * Return Code: DDI_SUCCESS
+ *		DDI_FAILURE
+ *
+ *     Context: Kernel thread context
+ */
+
+static int
+sddetach(dev_info_t *devi, ddi_detach_cmd_t cmd)
+{
+	switch (cmd) {
+	case DDI_DETACH:
+		return (sd_unit_detach(devi));
+	case DDI_SUSPEND:
+		return (sd_ddi_suspend(devi));
+	default:
+		break;
+	}
+	return (DDI_FAILURE);
+}
+
+
+/*
+ *     Function: sd_sync_with_callback
+ *
+ *  Description: Prevents sd_unit_attach or sd_unit_detach from freeing the soft
+ *		 state while the callback routine is active.
+ *
+ *    Arguments: un: softstate structure for the instance
+ *
+ *	Context: Kernel thread context
+ */
+
+static void
+sd_sync_with_callback(struct sd_lun *un)
+{
+	ASSERT(un != NULL);
+
+	mutex_enter(SD_MUTEX(un));
+
+	ASSERT(un->un_in_callback >= 0);
+
+	while (un->un_in_callback > 0) {
+		mutex_exit(SD_MUTEX(un));
+		delay(2);
+		mutex_enter(SD_MUTEX(un));
+	}
+
+	mutex_exit(SD_MUTEX(un));
+}
+
+/*
+ *    Function: sd_unit_attach
+ *
+ * Description: Performs DDI_ATTACH processing for sdattach(). Allocates
+ *		the soft state structure for the device and performs
+ *		all necessary structure and device initializations.
+ *
+ *   Arguments: devi: the system's dev_info_t for the device.
+ *
+ * Return Code: DDI_SUCCESS if attach is successful.
+ *		DDI_FAILURE if any part of the attach fails.
+ *
+ *     Context: Called at attach(9e) time for the DDI_ATTACH flag.
+ *		Kernel thread context only.  Can sleep.
+ */
+void
+sd_unit_attach(void *arg)
+{
+	dev_info_t		*devi = arg;
+	struct	scsi_device	*devp = ddi_get_driver_private(devi);
+	struct	sd_lun		*un = (struct sd_lun *)devp->sd_private;
+	char			name_str[48];
+	int	reservation_flag = SD_TARGET_IS_UNRESERVED;
+	int	rval;
+	int	wc_enabled;
+	int	wc_changeable;
+	int	tgt;
+	uint64_t	capacity;
+	uint_t		lbasize = 0;
+	dev_info_t	*pdip = ddi_get_parent(devi);
+	int		geom_label_valid = 0;
+	sd_ssc_t	*ssc;
+	int		status;
+	char		*devid;
+
+	/*
+	 * Retrieve the target ID of the device.
+	 */
+	tgt = ddi_prop_get_int(DDI_DEV_T_ANY, devi, DDI_PROP_DONTPASS,
+	    SCSI_ADDR_PROP_TARGET, -1);
+
+	/*
 	 * All command paths used below MUST issue their commands as
 	 * SD_PATH_DIRECT. This is important as intermediate layers
 	 * are not all initialized yet (such as PM).
 	 */
 
+	/* Initialize sd_ssc_t for internal uscsi commands */
+	ssc = sd_ssc_init(un);
+
 	/*
 	 * Send a TEST UNIT READY command to the device. This should clear
 	 * any outstanding UNIT ATTENTION that may be present.
@@ -7996,7 +7824,6 @@
 					    "is too large for a 32-bit "
 					    "kernel", capacity);
 
-#if defined(__i386) || defined(__amd64)
 					/*
 					 * 1TB disk was treated as (1T - 512)B
 					 * in the past, so that it might have
@@ -8004,10 +7831,9 @@
 					 * we have to allow it to continue to
 					 * work.
 					 */
-					if (capacity -1 > DK_MAX_BLOCKS)
+					if (capacity - 1 > DK_MAX_BLOCKS)
+						goto spinup_failed;
 #endif
-					goto spinup_failed;
-#endif
 				}
 
 				/*
@@ -8070,12 +7896,14 @@
 				 * spin-up succeeded. Just continue with
 				 * the attach...
 				 */
-				if (status == EIO)
+				if (status == EIO) {
 					sd_ssc_assessment(ssc,
 					    SD_FMT_STATUS_CHECK);
-				else
+					goto spinup_failed;
+				} else {
 					sd_ssc_assessment(ssc,
 					    SD_FMT_IGNORE);
+				}
 				break;
 			}
 			break;
@@ -8125,7 +7953,9 @@
 	 */
 	mutex_init(&un->un_pm_mutex, NULL, MUTEX_DRIVER, NULL);
 	cv_init(&un->un_pm_busy_cv, NULL, CV_DRIVER, NULL);
+#ifdef notyet
 	sd_setup_pm(ssc, devi);
+#endif
 	if (un->un_f_pm_is_enabled == FALSE) {
 		/*
 		 * For performance, point to a jump table that does
@@ -8160,7 +7990,7 @@
 	    sd_retry_on_reservation_conflict);
 	if (sd_retry_on_reservation_conflict != 0) {
 		sd_retry_on_reservation_conflict = ddi_getprop(DDI_DEV_T_ANY,
-		    devi, DDI_PROP_DONTPASS, sd_resv_conflict_name,
+		    devi, DDI_PROP_DONTPASS, "sd_retry_on_reservation_conflict",
 		    sd_retry_on_reservation_conflict);
 	}
 
@@ -8196,26 +8026,11 @@
 	 */
 	sd_check_emulation_mode(ssc);
 
-	cmlb_alloc_handle(&un->un_cmlbhandle);
-
-#if defined(__i386) || defined(__amd64)
-	/*
-	 * On x86, compensate for off-by-1 legacy error
-	 */
+	/* Compensate for off-by-1 legacy error */
 	if (!un->un_f_has_removable_media && !un->un_f_is_hotpluggable &&
 	    (lbasize == un->un_sys_blocksize))
-		offbyone = CMLB_OFF_BY_ONE;
-#endif
+		cmlb_workaround_off_by_one(un->un_cmlbhandle);
 
-	if (cmlb_attach(devi, &sd_tgops, (int)devp->sd_inq->inq_dtype,
-	    VOID2BOOLEAN(un->un_f_has_removable_media != 0),
-	    VOID2BOOLEAN(un->un_f_is_hotpluggable != 0),
-	    un->un_node_type, offbyone, un->un_cmlbhandle,
-	    (void *)SD_PATH_DIRECT) != 0) {
-		goto cmlb_attach_failed;
-	}
-
-
 	/*
 	 * Read and validate the device's geometry (ie, disk label)
 	 * A new unformatted drive will not have a valid geometry, but
@@ -8228,30 +8043,13 @@
 	mutex_enter(SD_MUTEX(un));
 
 	/*
-	 * Read and initialize the devid for the unit.
+	 * Read and initialize the devid for the unit if not done already.
 	 */
-	if (un->un_f_devid_supported) {
+	if (un->un_f_devid_supported && un->un_devid == NULL) {
 		sd_register_devid(ssc, devi, reservation_flag);
 	}
 	mutex_exit(SD_MUTEX(un));
 
-#if (defined(__fibre))
-	/*
-	 * Register callbacks for fibre only.  You can't do this solely
-	 * on the basis of the devid_type because this is hba specific.
-	 * We need to query our hba capabilities to find out whether to
-	 * register or not.
-	 */
-	if (un->un_f_is_fibre) {
-		if (strcmp(un->un_node_type, DDI_NT_BLOCK_CHAN)) {
-			sd_init_event_callbacks(un);
-			SD_TRACE(SD_LOG_ATTACH_DETACH, un,
-			    "sd_unit_attach: un:0x%p event callbacks inserted",
-			    un);
-		}
-	}
-#endif
-
 	if (un->un_f_opt_disable_cache == TRUE) {
 		/*
 		 * Disable both read cache and write cache.  This is
@@ -8363,6 +8161,7 @@
 	SD_TRACE(SD_LOG_ATTACH_DETACH, un,
 	    "sd_unit_attach: un:0x%p errstats set\n", un);
 
+	sd_setup_blk_limits(ssc);
 
 	/*
 	 * After successfully attaching an instance, we record the information
@@ -8380,16 +8179,20 @@
 	/* Uninitialize sd_ssc_t pointer */
 	sd_ssc_fini(ssc);
 
-	return (DDI_SUCCESS);
+	/* attach finished, switch to SD_STATE_NORMAL */
+	mutex_enter(SD_MUTEX(un));
+	New_state(un, SD_STATE_NORMAL);
+	cv_broadcast(&un->un_suspend_cv);
+	mutex_exit(SD_MUTEX(un));
 
+	return;
+
 	/*
 	 * An error occurred during the attach; clean up & return failure.
 	 */
+
 wm_cache_failed:
 devid_failed:
-	ddi_remove_minor_node(devi, NULL);
-
-cmlb_attach_failed:
 	/*
 	 * Cleanup from the scsi_ifsetcap() calls (437868)
 	 */
